
/* bar.prolog */
 /*  Heikki Välisuo */

/* Tässä on säännöt tahtien jakamiseksi beateihin ja näiden jakamiseksi edelleen osiin.
Tahti on ylempänä määrätty jako,
Bar jaon myötä syntyvä joukko tahdin nuotteja,
Ch on viivasto (kanava)
Instrum on valittu soitin ja
P0 ensimmäisen nuotin korkeus.
V0 on voimakkuus, jolla aloitetaan.
D0 on tahdin pituus tämän ohjelman yksiköissä.
Ta ja Tf ovat tahdin alku- ja loppuhetket */

barx(Tahti,Bar,Ch,Instrum,P0,Pf,Ta,Tf):-
%   fd_domain(V0,[50,70,90,110,125]),
	random(7,12,X),
	random(0,7,DescAsc),!,
	is(V0,10*X),
	iskut(Iskut),
    tahti_len(Tahti,D0),
    plim(P0,Instrum), plim(Pf,Instrum),
    Tf #=# Ta+D0,
    bar(Ta,Tahti,Bar,Ch,Instrum,D0,P0,Pf,V0,Iskut,tahti,DescAsc).

iskut(dvol(Dvol1,Dvol2,Dvol3,Dvol4,Dvol5,Dvol6,Dvol7,Dvol8)):-
  random(0,3,X1), random(2,4,X2), random(2,4,X3),
  random(2,4,X4), random(2,4,X5), random(2,4,X6),
  random(0,3,X7), random(0,3,X8),
  is(Dvol1,3*X1),is(Dvol2,3*X2),is(Dvol3,3*X3),is(Dvol4,3*X4),
  is(Dvol5,3*X5),is(Dvol6,3*X6),is(Dvol7,3*X7),is(Dvol8,3*X8).
%  fd_domain([Dvol1,Dvol3,Dvol5],[0,5,10]),
%  fd_domain([Dvol2,Dvol4,Dvol6],[10,15,20]),
%  fd_domain([Dvol7,Dvol8],[0,5,10]).

/* Tarjolla olevat mahdolliset jaot
['1_1', '1/2_1/2', '1/3_1/3_1/3', '1/4_1/4_1/4_1/4', '1/3_2/3', '1/4_1/4_1/2', '1/4_1/2_1/4']
1: ei jaeta osiin (tämä on poissuljettu ylemmällä tasolla, eli tahdissa on aina enemmän kuin yksi nuotti
1/2_1/2: tahti tai beat jaetaan kahteen yhtäsuureen osaan
jne. */

/* */

/* neljäsosanuotin pituus on tässä ohjelmassa 72. 3/4 tahdissa tahdin pituus on siis 216 ja 4/4 tahdissa 288 Muutakin olen kokeillut. */

tahti_len(['1/3_1/3_1/3'|_],216):- !.
tahti_len(['1/3_2/3'|_],216):- !.
tahti_len(['2/3_1/3'|_],216):- !.
tahti_len([_|_],288).

/* Varsinaiset jakosäännöt. Selitin malliksi ensimmäisen säännön ja alempana säännön 1/4_1/4_1/4_1/4  */

/* viimeinen parametri savel(isku_h), savel(isku_l), savel(perus), savel(loppu) tarkoittaa, että olemme määrittelemässä subbeatin yksittäistä nuottia note(Alkuaika, Kanava, Soitin, Nuotinpituus, Korkeus, Voimakkuus)   "Historiallisista" syistä tuo viimeinen parametri on turhan monimutkainen.
savel(isku_h) tarkoittaa, että kyseessä on tahdin tai beatin alussa oleva iskullinen nuotti,
savel(isku_l) tarkoittaa, että kyseessä tahdin tai beatin keskellä oleva iskullinen nuotti,*/

/* kaksi- ja kolmisointu iskullisille tahdeille */

bar(Tia,_,[note(Tia,Ch,Instr,Dx,P0a,V0a), note(Tia2,Ch,Instr,Dx,P0,V0a), note(Tia3,Ch,Instr,Dx,P0b,V0a),
%	note(Tia4,Ch,Instr,Dx,P0c,V0a),
	Rumpu], Ch, Instr, D0, P0,P0,V0,_,savel(isku_h(h)),_):-
    lplim([P0,P0a,P0b],Instr),
    Dz = 0,
    is(Dx,D0-2*Dz),
    is(Tia2,Tia+Dz),
    is(Tia3,Tia2+Dz),
%    is(Tia4,Tia3+Dz),
    V0a #=# V0//3,
    P0a #=# P0-4, P0b #=# P0+3, 
%	P0c #=# P0b+4,
    percus(Tia,isku_h(h),V0,Rumpu).
%    harmo(P0,P0a,P0b,P0c,savel(isku_h(h))).

bar(Tia,_,[note(Tia,Ch,Instr,Dx,P0a,V0a), note(Tia2,Ch,Instr,Dx,P0,V0a),
	note(Tia3,Ch,Instr,Dx,P0b,V0a),
	Rumpu], Ch, Instr, D0, P0,P0,V0,_,savel(isku_l(h)),_):-
%note(Tia4,Ch,Instr,Dx,P0c,V0a),
    lplim([P0,P0a,P0b],Instr),
    Dz = 0,
    is(Dx,D0-2*Dz),
    is(Tia2,Tia+Dz),
    is(Tia3,Tia2+Dz),
%    is(Tia4,Tia3+Dz),
    V0a #=# V0//3,
    P0a #=# P0-4, P0b #=# P0+3, % P0c #=# P0b+2,
    percus(Tia,isku_h(h),V0,Rumpu).

bar(Tia,_,[note(Tia,Ch,Instr,Dx,P0a,V0a), note(Tia2,Ch,Instr,Dx,P0,V0a),
%	note(Tia3,Ch,Instr,Dx,P0b,V0a),
	Rumpu], Ch, Instr, D0, P0,P0,V0,_,savel(isku_h(l)),_):-
%note(Tia4,Ch,Instr,Dx,P0c,V0a),
    lplim([P0,P0a],Instr),
    Dz = 0,
    is(Dx,D0-Dz),
    is(Tia2,Tia+Dz),
%    is(Tia3,Tia2+Dz),
%    is(Tia4,Tia3+Dz),
    V0a #=# V0//2,
    P0a #=# P0+4, % P0b #=# P0a+3, % P0c #=# P0b+2,
    percus(Tia,isku_h(h),V0,Rumpu).

bar(Tia,_,[note(Tia,Ch,Instr,D0,P0,V0),Rumpu],Ch,Instr,D0,P0,P0,V0,_,savel(isku_l(l)),_):-
%    (Isku=isku_l(l); Isku=isku_h(l)),
    percus(Tia,isku_l(l),V0,Rumpu),
    plim(P0,Instr).
bar(Tia,_,[note(Tia,Ch,Instr,D0,P0,V0),Rumpu],Ch,Instr,D0,P0,P0,V0,_,savel(perus),_):-
    percus(Tia,perus,V0,Rumpu),
    plim(P0,Instr).
bar(Tia,_,[note(Tia,Ch,Instr,D0,P0,V)],Ch,Instr,D0,P0,P0,V0,_,savel(loppu),_):-
    plim(P0,Instr),
    random(0,100,X),
    (X < 25 -> V=0; V #=# V0).
%    Df #=# D0.

bar(Tia,['1_1'|[Ta|Tb]],Bar,Ch,Instr,D0,P0,Pf,V0,Iskut,Btype,DescAsc):-
    beat_type(Btype,Isku,_,_,_),
    Ta=[T1,_,_,_,_],
    plim(P0,Instr),
    bar(Tia,[T1|Tb],Bar,Ch,Instr,D0,P0,Pf,V0,Iskut,Isku,DescAsc).

bar(Tia,['1/2_1/2'|[Ta|Tb]],Bar,Ch,Instr,D0,P0,Pf,V0,Iskut,Btype,DescAsc):-
    beat_type(Btype,Isku,_,_,Loppu),
    Ta=[T1,T2,_,_,_],
    D12 #=# D0//2,
    isku(V0,V2,_,Btype,Iskut),!,
    Tib #=# Tia+D12,
    lplim([P0,P1f,P2,Pf],Instr),
    steps([[P1f,P2]],Btype,DescAsc),
%    harmo(P0,P2,Btype),
    bar(Tia,[T1|Tb],B1,Ch,Instr,D12,P0,P1f,V0,Iskut,Isku,DescAsc),
    bar(Tib,[T2|Tb],B2,Ch,Instr,D12,P2,Pf,V2,Iskut,Loppu,DescAsc),
%	same_pitches([B1,B2]),
    append(B1,B2,Bar).

bar(Tia,['1/3_1/3_1/3'|[Ta|Tb]],Bar,Ch,Instr,D0,P0,Pf,V0,Iskut,Btype,DescAsc):-
    beat_type(Btype,Isku1,Isku2,_,Loppu),
    Ta=[T1,T2,T3,_,_],
    D13 #=# D0//3,
    isku(V0,_,V4,Btype,Iskut),!,
    Tib #= Tia+D13,Tic #= Tib+D13,
    lplim([P0,P1f,P2,P2f,P3,Pf],Instr),
    steps([[P1f,P2],[P2f,P3]],Btype,DescAsc),
%    harmo(P0,P2,P3,Btype),
    bar(Tia,[T1|Tb],B1,Ch,Instr,D13,P0,P1f,V0,Iskut,Isku1,DescAsc),
    bar(Tib,[T2|Tb],B2,Ch,Instr,D13,P2,P2f,V4,Iskut,Isku2,DescAsc),
    bar(Tic,[T3|Tb],B3,Ch,Instr,D13,P3,Pf,V4,Iskut,Loppu,DescAsc),
%	same_pitches([B1,B2,B3]),
    appnd([B1,B2,B3],Bar).

/* Jaetaan tahti tai beat neljään osaan eli "kutsutaan" neljä kertaa baria. Kunkin osan pituus D14 on neljäsosa jaettavana olevan osan pituudesta D0.
 steps() määrittelee osien välisen hypyn. Käytännössä se kieltää riitasointuiset hypyt.
isku() määrittelee voimakkuudet, millä osat soitetaan. V0 pääiskulle, V2 vähän heikommalle iskulle ja V4 sopii iskuttomalle beatille tai nuotille.
Jaot määrittäviä parametreja Ta, Tb jne. on pikkuisen vaikea hahmottaa, mutta ne ovat soinnulle aikaisemmin määrätyt jaot.
Tia,Tib,Tic ja Tid ovat beatin tai nuotin alkuhetket.
harmo() rajoittaa riitasointuja. Mikäli Btype kertoo, että B1,B2,B3 ja B4 ovat beateja, harmo ei tee mitään, mikäli taas ollaan alemmalla tasolla ja B1 - B4 ovat beatin nuotteja, harmo kieltää dissonanssin B1,B2,B3 ja B4:n kesken.
Lopuksi osat appendataan yhteen.
 */

bar(Tia,['1/4_1/4_1/4_1/4'|[Ta|Tb]],Bar,Ch,Instr,D0,P0,Pf,V0,Iskut,Btype,DescAsc):-
    beat_type(Btype,Isku1,Isku2,Perus,Loppu),
    Ta=[T1,T2,T3,T4,_],
    D14 #=# D0//4,
    isku(V0,V2,V4,Btype,Iskut),!,
    Tib #= Tia+D14,Tic #= Tib+D14,Tid #= Tic+D14,
    lplim([P0,P1f,P2,P2f,P3,P3f,P4,Pf],Instr),
    steps([[P1f,P2],[P2f,P3],[P3f,P4]],Btype,DescAsc),
%    harmo(P0,P2,P3,P4,Btype),
    bar(Tia,[T1|Tb],B1,Ch,Instr,D14,P0,P1f,V0,Iskut,Isku1,DescAsc),
    bar(Tib,[T2|Tb],B2,Ch,Instr,D14,P2,P2f,V4,Iskut,Perus,DescAsc),
    bar(Tic,[T3|Tb],B3,Ch,Instr,D14,P3,P3f,V2,Iskut,Isku2,DescAsc),
    bar(Tid,[T4|Tb],B4,Ch,Instr,D14,P4,Pf,V4,Iskut,Loppu,DescAsc),
%	same_pitches([B1,B2,B3,B4]),
    appnd([B1,B2,B3,B4],Bar).

bar(Tia,['1/3_2/3'|[Ta|Tb]],Bar,Ch,Instr,D0,P0,Pf,V0,Iskut,Btype,DescAsc):-
    beat_type(Btype,Isku1,_,_,Loppu),
    Ta=[T1,T2,_,_,_],
    D13 #=# D0//3,
    D23 #=# 2*D13,
    isku(V0,_,V4,Btype,Iskut),!,
    Tib #= Tia+D13,% Tic #= Tib+D14,Tid #= Tic+D14,
    lplim([P0,P1f,P2,Pf],Instr),
    steps([[P1f,P2]],Btype,DescAsc),
%    harmo(P0,P2,Btype),
    bar(Tia,[T1|Tb],B1,Ch,Instr,D13,P0,P1f,V0,Iskut,Isku1,DescAsc),
    bar(Tib,[T2|Tb],B2,Ch,Instr,D23,P2,Pf,V4,Iskut,Loppu,DescAsc),
%	same_pitches([B1,B2]),
    append(B1,B2,Bar).
bar(Tia,['2/3_1/3'|[Ta|Tb]],Bar,Ch,Instr,D0,P0,Pf,V0,Iskut,Btype,DescAsc):-
    beat_type(Btype,Isku1,_,_,Loppu),
    Ta=[T1,T2,_,_,_],
    D13 #=# D0//3,
    D23 #=# 2*D13,
    isku(V0,_,V4,Btype,Iskut),!,
    Tib #= Tia+D23,% Tic #= Tib+D14,Tid #= Tic+D14,
    lplim([P0,P1f,P2,Pf],Instr),
    steps([[P1f,P2]],Btype,DescAsc),
%    harmo(P0,P2,Btype),
    bar(Tia,[T1|Tb],B1,Ch,Instr,D23,P0,P1f,V0,Iskut,Isku1,DescAsc),
    bar(Tib,[T2|Tb],B2,Ch,Instr,D13,P2,Pf,V4,Iskut,Loppu,DescAsc),
%	same_pitches([B1,B2]),
    append(B1,B2,Bar).

bar(Tia,['1/4_1/4_1/2'|[Ta|Tb]],Bar,Ch,Instr,D0,P0,Pf,V0,Iskut,Btype,DescAsc):-
    beat_type(Btype,Isku1,_,Perus,Loppu),
    Ta=[T1,T2,T3,_,_],
    D14 #=# D0//4,
    D12 #=# D0//2,
    isku(V0,V2,V4,Btype,Iskut),!,
    Tib #= Tia+D14,Tic #= Tib+D14,%Tid #= Tic+D14,
    lplim([P0,P1f,P2,P2f,P3,Pf],Instr),
    steps([[P1f,P2],[P2f,P3]],Btype,DescAsc),
%    harmo(P0,P2,P3,Btype),
    bar(Tia,[T1|Tb],B1,Ch,Instr,D14,P0,P1f,V0,Iskut,Isku1,DescAsc),
    bar(Tib,[T2|Tb],B2,Ch,Instr,D14,P2,P2f,V2,Iskut,Perus,DescAsc),
    bar(Tic,[T3|Tb],B3,Ch,Instr,D12,P3,Pf,V4,Iskut,Loppu,DescAsc),
%	same_pitches([B1,B2,B3]),
    appnd([B1,B2,B3],Bar).
bar(Tia,['1/2_1/4_1/4'|[Ta|Tb]],Bar,Ch,Instr,D0,P0,Pf,V0,Iskut,Btype,DescAsc):-
    beat_type(Btype,Isku1,Isku2,_,Loppu),
    Ta=[T1,T2,T3,_,_],
    D14 #=# D0//4,
    D12 #=# D0//2,
    isku(V0,V2,V4,Btype,Iskut),!,
    Tib #= Tia+D12,Tic #= Tib+D14,%Tid #= Tic+D14,
    lplim([P0,P1f,P2,P2f,P3,Pf],Instr),
    steps([[P1f,P2],[P2f,P3]],Btype,DescAsc),
%    harmo(P0,P2,P3,Btype),
    bar(Tia,[T1|Tb],B1,Ch,Instr,D12,P0,P1f,V0,Iskut,Isku1,DescAsc),
    bar(Tib,[T2|Tb],B2,Ch,Instr,D14,P2,P2f,V2,Iskut,Isku2,DescAsc),
    bar(Tic,[T3|Tb],B3,Ch,Instr,D14,P3,Pf,V4,Iskut,Loppu,DescAsc),
%	same_pitches([B1,B2,B3]),
    appnd([B1,B2,B3],Bar).

/*
bar(Tia,['1/4_1/2_1/4'|[Ta|Tb]],Bar,Ch,Instr,D0,P0,Pf,V0,Btype):-
    beat_type(Btype,Isku1,Isku2,_,Loppu),
    Ta=[T1,T2,T3,_,_],
    D14 #=# D0//4,
    D12 #=# D0//2,
    isku(V0,V2,V4,Btype),
    Tib #= Tia+D14,Tic #= Tib+D12,% Tid #= Tic+D14,
    lplim([P0,P1f,P2,P2f,P3,Pf],Instr),
    steps([[P1f,P2],[P2f,P3]],Btype),
    harmo(P0,P2,P3,Btype),
    bar(Tia,[T1|Tb],B1,Ch,Instr,D14,P0,P1f,V0,Isku1),
    bar(Tib,[T2|Tb],B2,Ch,Instr,D12,P2,P2f,V2,Isku2),
    bar(Tic,[T3|Tb],B3,Ch,Instr,D14,P3,Pf,V4,Loppu),
    appnd([B1,B2,B3],Bar).
*/

/* Pääisku aloittaa tahdin. Toinen iskullinen nuotti soitetaan vähän vaimeammin voimakkuudella V2 ja perusnuotit voimakkuudella V4. Voimakkuus voi vaihdella välillä 0-127.
Beatien välillä käytän erona :tä, beatin sisällä :ttä. Iskullinen beat siis soitetaan kokonaan lujempaa kuin iskuton, mutta lisäksi kunkin beatin nuottien välillä on vastaava jako iskullisiin ja iskuttomiin.
*/

isku(V0,V2,V4,tahti,dvol(Dvol1,Dvol2,_,_,_,_,_,_)):-
    V2 #=# V0 - Dvol1,
    V4 #=# V2 - Dvol2.
isku(V0,V2,V4,beat(isku_h),dvol(_,_,Dvol3,Dvol4,_,_,_,_)):-
    V2 #=# V0 - Dvol3,
    V4 #=# V2 - Dvol4.
isku(V0,V2,V4,beat(isku_l),dvol(_,_,_,_,Dvol5,Dvol6,_,_)):-
    V2 #=# V0 - Dvol5,
    V4 #=# V2 - Dvol6.
isku(V0,V2,V4,beat(perus),dvol(_,_,_,_,_,_,Dvol7,Dvol8)):-
    V2 #=# V0 - Dvol7,
    V4 #=# V2 - Dvol8.

isku(A,B,C,D,E):- write(isku(A,B,C,D,E)), write(' failed '),nl,halt.

/* Minulla on aavistus, että seuraava on pikkuisen turhan monimutkainen.
Yllä bar() predikaatin voisi jakaa kahdeksi seuraavaan tapaisesti

tahti([B1,B2,...]):-
    beat(B1),beat(B1), ...

beat([N1,N2,...]):-
    savel(N1), savel(N2),

nyt bar() "hoitaa" sekä beatin että savelen tehtävät ja beat_type kertoo, kummasta on kyse
*/

beat_type(tahti,beat(isku_h),beat(isku_l),beat(perus),beat(perus)). % jaetaan tahtia beateiksi
beat_type(beat(isku_h),savel(isku_h(h)),savel(isku_h(l)),savel(perus),savel(loppu)). % jaetaan beatia säveliksi
beat_type(beat(isku_l),savel(isku_l(h)),savel(isku_l(l)),savel(perus),savel(loppu)). % jaetaan beatia säveliksi
beat_type(beat(perus),savel(perus),savel(perus),savel(perus),savel(loppu)). % jaetaan beatia säveliksi

/* steps rajoittaa beatien välisiä askelia. Joidenkin säkeiden ajan se lisäksi vaatii beatit tai beatin sävelet nousevaan tai laskevaan järjestykseen. */

steps([[P1,P2]],tahti,_):-
%    fd_domain(Dp1,[4,5,7,9,12]),
%    fd_domain(Dp1,[3,6,8,10,11,13,14,15]),
	Dp1 #=# dist(P2,P1),
	step_h([Dp1]).
steps([[P1,P2],[P3,P4]],tahti,_):-
%    fd_domain([Dp1,Dp2],[3,6,8,10,11,13,14,15]),
	Dp1 #=# dist(P2,P1), 
	Dp2 #=# dist(P3,P4),
	step_h([Dp1,Dp2]).
steps([[P1,P2],[P3,P4],[P5,P6]],tahti,_):-
%    fd_domain([Dp1,Dp2,Dp3],[3,6,8,10,11,13,14,15]),
	Dp1 #=# dist(P2,P1), 
	Dp2 #=# dist(P3,P4), 
	Dp3 #=# dist(P5,P6),
	step_h([Dp1,Dp2,Dp3]).

%
steps([[P1,P2]],Tahti,DescAsc):-
	Tahti \== tahti,
%    fd_domain(Dp1,[3,4,5,7,9]),
	Dp1 #=# dist(P2,P1),
	step_l([Dp1]),
	desc_asc(P1,P2,_,_,DescAsc).
steps([[P1,P2],[P3,P4]],Tahti,DescAsc):-
	Tahti \== tahti,
%    fd_domain([Dp1,Dp2],[3,4,5,7,9]),
	Dp1 #=# dist(P2,P1), 
	Dp2 #=# dist(P3,P4), 
	step_l([Dp1,Dp2]),
	desc_asc(P1,P2,P4,_,DescAsc).
steps([[P1,P2],[P3,P4],[P5,P6]],Tahti,DescAsc):-
	Tahti \== tahti,
%    fd_domain([Dp1,Dp2,Dp3],[4,5,7,9]),
	Dp1 #=# dist(P2,P1), 
	Dp2 #=# dist(P3,P4), 
	Dp3 #=# dist(P5,P6), 
	step_l([Dp1,Dp2,Dp3]),
	desc_asc(P1,P2,P4,P6,DescAsc).

step_h([]).
step_h([D|DD]):-
    D #># 2, 
    D #\=# 4, 
	D #\=# 5, D #\=# 7, D #\=# 9, D #\=# 12, 
	D #<# 14,
	step_h(DD).

step_l([]).
step_l([D|DD]):-
    D #\=# 0, 
	D #\=# 1, 
%	D #\=# 2, 
%	D #\=# 3, 
	D #\=# 6, D #\=# 8, D #\=# 10, D #\=# 11, D #=<# 12,
	step_l(DD).
  

harmo2([_]).
harmo2([H1|[H2|T]]):-
%	fd_domain(D,[4,5,7,9]), % 3?, 
    dist(H1,H2) #=# Do,
    D #=# Do rem 12,
    dissonance_filter([D]),
    harmo2([H2|T]).

/* Liekkö nämä oikeasti pahimmat riitasoinnut ?  */

dissonance_filter([]).
dissonance_filter([D1|Dn]):-
%  D1 #\=# 0, 
  D1 #\=# 1, D1 #\=# 2, 
%  D1 #\=# 3, 
  D1 #\=# 6, D1 #\=# 8, D1 #\=# 10, D1 #\=# 11,
  dissonance_filter(Dn).


desc_asc(_,_,_,_,_).
/*
desc_asc(P1,P2,P3,P4,1):- !,
  P1 #=<# P2,P2 #=<# P3, P3 #=<# P4.
desc_asc(P1,P2,P3,P4,2):- !,
  P1 #>=# P2,P2 #>=# P3, P3 #>=# P4.
desc_asc(P1,P2,P3,P4,3):- !,
  P1 #=<# P2,P2 #>=# P3, P3 #=<# P4.
desc_asc(P1,P2,P3,P4,4):- !,
  P1 #>=# P2,P2 #=<# P3, P3 #>=# P4.
desc_asc(_,_,_,_,_).
*/
  
/*
steps2(P1,P2,P3,P4,tahti,_):-
    fd_domain([Dp1,Dp2,Dp3],[0,4,5,7,9,12]),
	Dp1 #=# P2 - P1, 
	Dp2 #=# P3 - P2, 
	Dp3 #=# P4 - P3. 
steps2(P1,P2,P3,P4,Btype,DescAsc):-
    member(Btype,[beat(isku(_h),beat(isku_l),beat(perus)]),
    fd_domain([Dp1,Dp2,Dp3],[0,4,5,7,9,12]),
	Dp1 #=# P2 - P1, 
	Dp2 #=# P3 - P2, 
	Dp3 #=# P4 - P3, 
    fd_domain([Dp1,Dp2,Dp3],[0,4,5,7,9,12]),
  desc_asc(DescAsc,P1,P2,P3,P4).
*/


/*
steps([],_).
%steps([[A,B]|An],tahti):-
steps([[A,B]|An],Tahti):-
%    fd_domain(D,[0,2,4,5,7,9]),
    fd_domain(D,[0,4,5,7,9,12]),
    dist(A,B) #=# D,
%    desc_asc_h(A,B),
    steps(An,Tahti).
%steps([[A,B]|An],beat(_)):-
%    member(Btype,[beat(isku(_h),beat(isku_l),beat(perus)]),
%    desc_asc_l(A,B),
%    steps(An,beat(_)).
*/
/*
same_pitches(Bar):-
  poista_soinnut(Bar,B),
  same_pitches1(B).

poista_soinnut([],[]).  
poista_soinnut([Ba1|Ban],[Bb1|Bbn]):-
  poista_sointu(Ba1,Bb1),
  poista_soinnut(Ban,Bbn).


poista_sointu([],[]).
poista_sointu([note(T,_,_,_,_,_)|[note(T,A,B,C,D,E)|Notes]],Bar):- !,
  poista_sointu([note(T,A,B,C,D,E)|Notes],Bar).
poista_sointu([note(_,_,percussion,_,_,_)|Notes],B):- !,
  poista_sointu(Notes,B).
poista_sointu([A|B],[A|C]):- poista_sointu(B,C).

%same_pitches([]):- write('=').
same_pitches1([Beat1,Beat2]):-
  random(0,100,X),!,
  (X < 50 -> same_pitches2(Beat1,Beat2); true),!.
same_pitches1([Beat1|[Beat2|Beatn]]):-
  random(0,100,X),!,
  (X < 50 -> same_pitches2(Beat1,Beat2); true),
  same_pitches1([Beat2|Beatn]). % ei kattava
same_pitches1(_):- !, write('#').

same_pitches2([],[]):- !, write('+'). 
same_pitches2([note(_,_,_,_,Pa,_)|Beat_a],[note(_,_,_,_,Pb,_)|Beat_b]):- 
  Pa #=# Pb,!,  write('.'),
  same_pitches2(Beat_a,Beat_b).
same_pitches2(_,_):- !. %:- write('-').
*/
/*
note(Tia,Ch,Instr,Dx,P0a,V0a)
*/
/*  
desc_asc_h(A,B):-
    g_read(n_sae,N_sae),
    is(Mode,N_sae rem 5),
    desc_asc_h(A,B,Mode).
desc_asc_l(A,B):-
    g_read(n_sae,N_sae),
    is(Mode,N_sae rem 4),
    desc_asc_h(A,B,Mode).

desc_asc_h(_,_,0).
desc_asc_h(_,_,1).
desc_asc_h(_,_,2).
desc_asc_h(A,B,2):- A #=<# B.
desc_asc_h(_,_,3).
desc_asc_h(_,_,4).
%desc_asc_h(A,B,4):- A #>=# B.

desc_asc_l(_,_,0).
desc_asc_l(A,B,1):- A #=<# B.
desc_asc_l(_,_,2).
desc_asc_l(A,B,3):- A #>=# B.
*/

/* harmo rajoittaa dissonanssia kahden, kolmen tai neljän sävelen väliltä. Tätä käytetään beatien nuotteihin. Ehkä turhankin tiukka sääntö.

Rajoituksen sijasta voisi määritellä relaation, joka kuvaa sallitut vaihtoehtoiset relaatiot näiden sävelten välillä. Näin voisi tarkemmin määritellä beatien rakennetta. Ohjelmasta tulee kuitenkin sillä tavalla laskennalliseti paljon raskaampi tai sitten pitää tehdä paljon lisää ajatustyötä.
Toki tuotakin vaihtoehtoa kokeilin, mutta ei se paljon kummoisemmalta kuulostanut.
 */
/*
harmo(_,_,tahti).
harmo(A,B,Btype):-
    (Btype=beat(_); Btype=savel(_)),
%    member(Btype,[beat(isku_h),beat(isku_l),beat(perus),savel(isku_h),savel(isku_l)]),
    dist(A,B) #=# D1,
    dissonance([D1]).

harmo(_,_,_,tahti).
harmo(A,B,C,Btype):-
    (Btype=beat(_); Btype=savel(_)),
%    member(Btype,[beat(isku_h),beat(isku_l),beat(perus),savel(isku_h),savel(isku_l)]),
    dist(A,B) #=# D1,
    dist(B,C) #=# D2,
    dist(A,C) #=# D3,
    dissonance([D1,D2,D3]).
harmo(_,_,_,_,tahti).
harmo(A,B,C,D,Btype):-
    (Btype=beat(_); Btype=savel(_)),
%    member(Btype,[beat(isku_h),beat(isku_l),beat(perus),savel(isku_h),savel(isku_l)]),
    dist(A,B) #=# D1,
    dist(B,C) #=# D2,
    dist(A,C) #=# D3,
    dist(C,D) #=# D4,
    dist(B,D) #=# D5,
    dist(A,D) #=# D6,
    dissonance([D1,D2,D3,D4,D5,D6]).
*/
/* Vastaava kuin edellinen, mutta sallii yli oktaavin intervallit. Tätä käytetään estettäessä yhtäaikaa soivien sävelten dissodanssia. Tätä sovelletaan algoritmissa, joka käy - tehottomasti - läpi kaikki intervallit, joten ei haittaa, vaikka tämä tarkastelee vain kahta säveltä kerrallaan.
 */
% ++++++++++++++++++++++
/*
transpose(_,_,[],[]).
transpose(Oct,Dv,[note(_,10,_,_,_,_)|An],[note(_,10,_,_,_,_)|Bn]):-
    !,transpose(Oct,Dv,An,Bn).
transpose(Oct,Dv,[note(_,_,_,_,P0,V0)|An],[note(_,_,_,_,P1,V1)|Bn]):-
    (dist(P0,P1) #=# Oct -> true; write((dist(P0,P1) #=# Oct))),
  ((V0 = 0; V1 = 0; dist(V0,V1) #># 5) -> true; write(volums(V0,V1))), % write(' dv: '), write(D), 
%    (dist(V0,V1) #># 0; V0 == 0; V1 == 0),
%(V1 #=# V0 - Dv; V0 =\= 0; V1 =\= 0), 
    !,transpose(Oct,Dv,An,Bn).

transpose(Oct,Dv,[note(_,_,_,_,P0,V0)|An],[note(_,_,_,_,P1,V1)|Bn]):-
  write(transpose(Oct,Dv,[note(_,_,_,_,P0,V0)|An],[note(_,_,_,_,P1,V1)|Bn])),
  halt.
*/

/*
Intervallien nimitykset perustuvat latinankielisiin järjestyslukuihin. Antiikin roomalaiset eivät tunteneet nollaa, joten intervalleja laskettaessa on otettava aina lähtösävel mukaan. Jos kahden sävelen väliin jäävien diatonisten sävelaskelten lukumäärä on nolla, intervallia kutsutaan priimiksi (merkitään numerolla 1). Jos sävelaskelia jää yksi, intervallia kutsutaan sekunniksi (2) jne.

Intervallien nimitykset ja niitä vastaavat numerosymbolit, jotka viittaavat etäisyyteen diatoniseen asteikkoon pohjautuvalla nuottiviivastolla:

priimi 	1 	oktaavi 	8 	kvintdesiimi 	15
sekunti 	2 	nooni 	9
terssi 	3 	desiimi 	10
kvartti 	4 	undesiimi 	11
kvintti 	5 	duodesimi 	12
seksti 	6 	tredesiimi 	13
septimi 	7 	kvartdesiimi 	14

Duuriasteikon perussävelestä ylöspäin lukien priimi (1), kvartti (4), kvintti (5) ja oktaavi (8) ovat puhtaita.

Musiikinteoriassa konsonanssit jaetaan perinteisesti kahteen ryhmään: avosävyisiin ja sointusävyisiin. Puhtaat intervallit (1, 4, 5, 8) ovat avosävyisiä ja niitä kutsuttiin keskiajan moniäänisessä musiikissa myös täydellisiksi konsonansseiksi. Sointusävyiset (3 ja 6) taas joko suuria tai pieniä (keskiajalla epätäydellisiä konsonansseja).



Yleisimmät intervallit ja niitä vastaavat taajuuksien suhteet ovat:
Nimi 		Esimerkki 		Puoliaskelien lkm 	Taajuuksien suhde
Priimi 	 			C - C 		0 				1:1
Pieni sekunti  		C - Des 	1			 	16:15
Suuri sekunti		C - D 		2			 	9:8 (tai 10:9)
Pieni terssi 	 	C - Es 		3			 	6:5
Suuri terssi		C - E 		4		 		5:4
Kvartti 	 		C - F 		5			 	4:3
Ylinouseva kvartti 	C - Fis 	6	 			45:32
Vähennetty kvintti	C - Ges 	6 				64:45
Kvintti 	 		C - G 		7			 	3:2
Pieni seksti  		C - As 		8 				8:5
Suuri seksti		C - A 		9 				5:3
Pieni septimi 		C - B 		10 				16:9
Suuri septimi		C - H 		11 				15:8
Oktaavi 			C - c	 	12 				2:1


I	II	III	IV	V	VI	VII	VIII
1	2	3	4	5	6	7	8	(intervalli)
C	D	E	F	G	A	H	C	(savel)
0	2	4	5	7	9	11	12	(puoliaskeleet)
x		x	x	x	x		x

duurikolmisointu I III V

septimisoinnussa ovat intervallit 3, 5 ja 7
kvinttisekstisoinnussa 3, 5 ja 6
terssikvarttisoinnussa 3, 4 ja 6
sekuntisoinnussa 2, 4 ja 6
*/

/*    B  #=# A + D1 - 10 ,
    C #=# B + D2 - 10,
    fd_relation([
	    [14,13],
%	    [14,3],
	    [6,7],
%	    [7,17],
	    [12,12],
	    [8,8]
	    ],[D1,D2]).
*/
/*
harmo(A,B,C,D,Btype):-
    member(Btype,[beat(isku_h),beat(isku_l),beat(perus)]),
    B - A #=# D1 - 10,
    C - B #=# D2 - 10,
    D - C #=# D3 - 10,
    fd_relation([
	[14,13,12],
	[6,7,8],
%	[15,1,8],
%	[12,13,1],
	[12,12,12],
	[8,8,8]
	],[D1,D2,D3]).
% 4,7,9
*/
