
/* soitin.pl Soittimien määrittelyt */

/* Soitin on oikeastaan soitinryhmä, joista valitaan soitettavaksi kerrallaan yksi tai useampi. Soitinryhmästä on kuitenkin äänessä kerrallaan vain yksi soitin. Esimerkiksi soitin 1 soittaa jotain torviksi määrittelemistäni instrumenteista. */

dynamic(soitetaan(1)).

bandi_name(kaikki).

demo:- 
    setof(S,ss(S),SS),
    length(SS,N), format(' ~d soitinta~n',[N]),
    demo(SS,1,N).

demo([],_,_).
demo([S1|Sn],K,Max):-
    asserta(soitetaan(S1)),
    format('~a ~d:s soitin ~d:sta~n',[S1,K,Max]),
    melody(72,4,[1]),
    is(L,K+1),
    demo(Sn,L,Max).

soitin(1,[Instrum],t4):- soitetaan(Instrum).


sel_instrum([],[]).
sel_instrum([Ryhma1|Ryhman],Instruments):-
    setof(Soitin,instrument(Ryhma1,Soitin),Instr1),
    sel_instrum(Ryhman,Instrun),
    append(Instr1,Instrun,Instruments).

instrument(Ryhma,Soitin):- instrument(Ryhma,Soitin,_,_).

instrument(torvi3,'Trumpet',56,0).
instrument(torvi1,'Trombone',57,0).
instrument(torvi1,'Tuba',58,0).
instrument(torvi,'FrenchHorns',60,0).
instrument(torvi3,'BrassSection',61,0).
instrument(torvi2,'SopranoSax',64,0).
instrument(torvi2,'AltoSax',65,0).
instrument(torvi2,'TenorSax',66,0).
instrument(torvi2,'BaritoneSax',67,0).
instrument(torvi,'Oboe',68,0).
instrument(torvi,'EnglishHorn',69,0).
instrument(torvi4,'Clarinet',71,0).

instrument(piano,'YamahaGrandPiano',0,0).
instrument(piano,'BrightYamahaGrand',1,0).
instrument(piano1,'HonkyTonk',3,0).
instrument(piano,'LegendEP2',5,0).
instrument(piano,'Clavinet',7,0).
instrument(kello2,'Glockenspiel',9,0).
instrument(kello2,'Vibraphone',11,0).
instrument(kello,'Marimba',12,0).
instrument(kello2,'Xylophone',13,0).
instrument(kello2,'TubularBells',14,0).
instrument(kello2,'Dulcimer',15,0).
instrument(urut1,'DrawbarOrgan',16,0).
instrument(urut2,'PercussiveOrgan',17,0).
instrument(urut2,'RockOrgan',18,0).
instrument(urut,'ChurchOrgan',19,0).
instrument(urut2,'ReedOrgan',20,0).
instrument(kitara,'NylonStringGuitar',24,0).
instrument(kitara1,'SteelStringGuitar',25,0).
instrument(kitara,'JazzGuitar',26,0).
instrument(kitara,'CleanGuitar',27,0).
instrument(basso,'AcousticBass',32,0).
instrument(basso,'FingeredBass',33,0).
instrument(basso,'PickedBass',34,0).
instrument(basso,'FretlessBass',35,0).
instrument(jousi,'Violin',40,0).
instrument(jousi,'Cello',42,0).
instrument(harppu1,'PizzicatoSection',45,0).
instrument(harppu,'Harp',46,0).
instrument(jousi,'Strings',48,0).
instrument(jousi,'SlowStrings',49,0).
instrument(huilu1,'Piccolo',72,0).
instrument(huilu1,'Flute',73,0).
instrument(huilu,'PanFlute',75,0).
instrument(huilu2,'BottleChiff',76,0).
instrument(huilu,'Ocarina',79,0).
instrument(huilu2,'CalliopeLead',82,0).
instrument(kello2,'Fantasia',88,0).
instrument(huilu1,'SpaceVoice',91,0).
instrument(kello2,'BowedGlass',92,0).
instrument(kello2,'Crystal',98,0).
instrument(huilu1,'Atmosphere',99,0).
instrument(harppu2,'Sitar',104,0).
instrument(harppu2,'Shamisen',106,0).
instrument(jousi,'Fiddle',110,0).
instrument(kello2,'TinkerBell',112,0).
instrument(rumpu,'Agogo',113,0).
instrument(rumpu,'Woodblock',115,0).
instrument(rumpu,'TaikoDrum',116,0).
instrument(rumpu,'MelodicTom',117,0).
