
/* labeling.pl */
 /*  Heikki Välisuo */

/* Tämä ohjelma soveltaa nk. rajoitusohjelmointia ja test-and-generate periaatetta nuottien korkeuden ja soiton voimakkuuden osalta. Nuoteille annetaan aluksi erilaisia sääntöjä, jotka rajoittavat niiden arvoa ja niiden riippuvuutta toisistaan. Vasta tämän jälkeen kokeillaan, mitkä mahdollisista arvoista sopivat kaikkiin rajoitusehtoihin. Saattaa kuulostaa hullulta, mutta on paljon helpompaa kuin toisinpäin. 
fd_labeling tekee työn jollain matemaatikkojen kehittämällä minulle tuntemattomalla tavalla. 

prologia tunteville: Tämä ohjelma ei juurikaan backtrackaa muuta kuin fd_labeling algoritmin sisällä. Vaihtoehdoista valitaan yksi satunnaisesti. Useimmat predikaatit vain lisäävät muuttujiin jonkin rajoituksen eivätkä tarjoa vaihtoehtoja. Siksi tässä ohjelmassa on joitakin kummallisia rakenteita. Esimerkiksi poikkeavuuksista voi raportoida lisäilemällä ohjelmaan predikaatteja, jotka backtrackatessa antavat virheilmoituksen. Pinojen säästämiseksi olen myös käyttänyt !:a paljon. 
*/ 

label(XX,_):-
    flatten_tahdit(XX,SS),!,  % tahtien lista nuottien listaksi
    consonance(SS),!, % kielletään dissodanssit
%    is(Len_sae,3*288+72+2*27), 
%    is(Max,Nsae*Len_sae),
 %   is(N_stp, Max//288),
    label3(SS),!.
%    consonance(SS),!.

/* Poimitaan nuottien jonosta taajuudet ja volyymit listoikseen. fd_labeling hakee niille rajoitusten sallimat arvot. Muuttujista käsitellään ensin ne, joille on asetettu eniten rajoituksia. Muuttujille kokeillaan sallituissa rajoissa arvoja satunnaisesti. 
 */

label3(SS):-
%    trace,leash([]),
    pick_notes(SS,P,V),   
    appnd([P,V],PV),!,
    message('labeling failed'),
    format('labeling ... ~n',[]),
    fd_labeling(PV,[variable_method(most_constrained),reorder(true),value_method(random),backtracks(B)]),
%    fd_labeling(PV,[variable_method(most_constrained),reorder(false),value_method(random),backtracks(B)]),
    format('backtracks ~d ~n',[B]).

%   fd_labeling(PV,[variable_method(random),value_method(random),backtracks(B)]),

/* Tehdään listojen listoista yksinkertaisia listoja. */
flatten_tahdit([],[]):- !.
flatten_tahdit([note(Ta,Ch,Instrument,A,B,C)|T],[note(Ta,Ch,Instrument,A,B,C)|T]):- !.
flatten_tahdit([A|B],F):-
    flatten_tahdit(A,Af),flatten_tahdit(B,Bf),
    append(Af,Bf,F).

/* rajataan samanaikaa soivien savelten riitasointuja.
Yritin saada mukaan rajoituksen samaan aikaan soivien sävelten voimakkuuksille, mutta siihen jäi jokin vika, jota en jaksanut etsiskellä. */

consonance([]).
consonance([H|T]):-
    conson(H,T,PP,_),!,
    harmo2(PP),
%    message(dups(VV,VVd)),
%   dupls(VV,VVd),!,
%    message(volume_limit(VV)),
%    volume_limit(VVd,500),!,
    consonance(T).

/*
volume_limit([],_). %:- X #=<# 560.
volume_limit([V1|Vn],Vlim):-
    X #>=#0,
    X+V1 #=# Vlim,
    message(volume_limit([V1|Vn],Vlim)),
    volume_limit(Vn,X).
*/
 
conson(note(_,_,_,_,P,V),[],[P],[V]).
conson(note(Ta1,Ch1,_,D1,P1,V1),[note(Ta2,Ch2,_,D2,P2,V2)|T],[P2|PP],[V2|VV]):-
    Ch1 =\= Ch2, Ch1 =\= 10, Ch2 =\= 10,
    overlap([Ta1,D1],[Ta2,D2]),!,
    conson(note(Ta1,Ch1,_,D1,P1,V1),T,PP,VV).
conson(note(Ta1,Ch1,_,D1,P1,V1),[note(_,_,_,_,_,_)|T],PP,VV):-
    conson(note(Ta1,Ch1,_,D1,P1,V1),T,PP,VV).
conson(note(Ta1,Ch1,Instr,D1,P1,V1),[note(Ta2,Ch2,Instr2,D2,P2,V2)|_],_,_):-
    write(conson(note(Ta1,Ch1,Instr,D1,P1,V1),[note(Ta2,Ch2,Instr2,D2,P2,V2)])),nl,fail.

overlap([Ta1,D1],[Ta2,D2]):-
    is(Tf1,Ta1+D1), is(Tf2,Ta2+D2),
    ((Ta1  =< Ta2, Ta2 < Tf1);
    (Ta2  =< Ta1, Ta1 < Tf2)).
%    write(overlap([Ta1,D1],[Ta2,D2])),nl.

/*
dupls([H],[H]).
dupls([note(Ta1,Ch1,Ins1,D1,P1,V1)|[note(Ta1,Ch2,Ins2,D1,P2,V2)|T]],SS):- !,
    dupls([note(Ta1,Ch1,Ins1,D1,P1,V1)|T],SS).
dupls([H1|[H2|T]],[H1|SS]):- !,
    dupls([H2|T],SS).
 */

pick_notes([],[],[]).
pick_notes([note(_,_,_,_,P,V)|Bn],[P|Pn],[V|Vn]):-
    ctest(P), ctest(V),
%    guide_dist(Instr,T,P),
    pick_notes(Bn,Pn,Vn).

/*
pick_notes(Ta,Tf,[note(T,_,_,_,_,_)|Bn],Pn,Vn,Dist):-
    (Ta > T; T > Tf),
   pick_notes(Ta,Tf,Bn,Pn,Vn,Dist).
*/

guide_dist(percussion,_,_):- !.
guide_dist(Instr,T,P):-
    plim(Tmp,Instr),
    fd_min(Tmp,Pmin),
    fd_max(Tmp,Pmax),
    is(Tahti,T rem 288),
    is(Guide1,(Tahti rem 3) - ((Tahti-1) rem 3)),
    is(Guide,(Pmin+Pmax)//2+(Pmax-Pmin)//4*Guide1), 
    (Guide < Pmin -> format('guide low error ~d ~d ~n',[Guide,Pmin]); true),
    (Guide > Pmax -> format('guide high error ~d ~d ~n',[Guide,Pmax]); true),
    message(g_dist(P,Guide,T,Instr)),
    (dist(P,Guide) #=<# 12; true).

ctest(X):-
    fd_has_extra_cstr(X) -> (write('ctest: '),write(X),nl); true.

appnd([L1|[L2|[]]],LL):- append(L1,L2,LL).
appnd([L1|Ln],LL):-
    appnd(Ln,X),
    append(L1,X,LL).

message(_,_).
message(X,Y):- write('!!!!!!!! '),nl,write(X), nl, write(Y),nl,halt.

message(_).
message(X):- write(X), nl,halt.

messg(_,[]):- nl.
messg(Msg,[X|Xn]):- 
    write(Msg),write(' '),fd_dom(X, Xdom), write(Xdom), nl,
    messg(Msg,Xn).

messag(_).
messag(X):- write('varoitus  '),write(X),nl.

/*
label2(_,M,N):- N > M.
label2(SS,N_stp,K):-
    is(Ta,K*288),
    is(Tf,Ta+288+72),
    pick_notes(Ta,Tf,SS,P,V),
    appnd([P,V],PV),!,
    message('labeling failed'),
    format('labeling ~d ~d...~n',[Ta,Tf]),
%   fd_labeling(PV,[variable_method(random),value_method(random),backtracks(B)]),
  fd_labeling(PV,[variable_method(most_constrained),value_method(random),backtracks(B)]),
    write(' backtracks: '), write(B),!,
    is(L,K+1),
    label2(SS,N_stp,L).
*/
