
/* melody pl */
 /*  Heikki Välisuo */

/* Ohjelmoinnista yleensä:

Olen oppinut, että koodista kannattaa pyrkiä tekemään mahdollisimman eleganttia, koska silloin sitä on helpompi modifioida ja virheitäkin tulee vähemmän. Kun pikkuisen ponnistelee löytääkseen elegantin ratkaisun, oppii paremmaksi ohjelmoijaksi. Usein elegantein ratkaisu on myös helpoin ja nopein koodata - kunhan taidon on ensin oppinut.

Aina välillä olen lipsunut ja nyt sormet syyhyävät parantelemaan ohjelmaa.

Algoritmin tehokkuus ja eleganttius kulkevat nekin usein käsi kädessä, mutta joskus on helppo koodata yksinkertainen mutta tehoton algoritmi. Toisissa kohdin ohjelmaa tehokkuus on tärkeää, toisissa kohdin ei. Todella harvoin kannattaa yleispätevyydestä luopua tehokkuuden nimissä. */

/* Määrittelin erilllisiin tiedostoihin "orkestereita" ja kappaleita. Bandit soittaa kultakin demon tai pari. Oma tiedosto kullekin orkesterille on tarpeen, koska ohjelman rakenne ei ole kyllin fiksu.*/

bandit(Kesto):- bandit1(Kesto), bandit2(Kesto).

bandit1(Kesto):-
    bandi('torvet.prolog',Kesto),!,
    bandi('kitarat.prolog',Kesto),!,
    bandi('harppu.prolog',Kesto),!.
%%    bandi(rummut),sleep(3),
bandit2(Kesto):-
    bandi('jouset.prolog',Kesto),!,
    bandi('urut.prolog',Kesto),!,
    bandi('rummut.prolog',Kesto),!,
    bandi('huilut.prolog',Kesto),!.

bandi(Bandi,Kesto):- consult([Bandi]), demo(Kesto),!.

/* naytteet tuottaa esimerkkikappaleita */
naytteet:-
    melody(72,12,[1,2]), sleep(2),
    melody(72,12,[3,4]), sleep(2),
    melody(72,12,[5,6]), sleep(2),
    melody(72,12,[7,8]), sleep(2),
    melody(72,12,[9,11]), sleep(2),
    melody(48,12,[12,13]),sleep(2),
    melody(72,12,[14,15]),sleep(2).

/* melody(Tempo,Nsae,Chs) soittaa melodian.
Tempo kertoo, montako Midi-yksikköä neljännesnuotti on. Tässä ohjelmassa tahti on 144 yksikköä pitkä, joten neljäsosanuotin kesto  on 36. Suuremnalla luvulla saa ohjelman huijattua lisäämään tempoa.
Nsae kertoo, montako kuuden tahdin sointua soitetaan.
Chs, kanavat, kertoo äänet, jotka soittavat yhtaikaa. Kanavan voi ajatella yhdeksi viivastoksi nuoteissa. Tässä ohjelmassa kunkin viivaston nuotit syötetään omalle midi-kanavalleen.
Tiedostossa soittimet.pl määritellään, mitkä soittimet milläkin kanavalla soivat.*/

melody(Tempo,Nsae,Chs):-
    nl, soitinlista(Chs),
    init(Midi,Fmid,Chs),    % tietoteknistä valmistelua
    midi_init2(Midi,Tempo),    % tietoteknistä valmistelua
    cpu_time(Ta),
    stafs(Stafs,Chs,Nsae),!,  % luodaan melodian nuotit
    label(Stafs,Nsae),!,
    cpu_time(Tf),
    is(T,Tf - Ta),
    format('generation cputime: ~d   ',[T]),
%    write('generation cputime: '), write(T),
    playnotes(Stafs,Midi,Fmid,Chs),!, % käännetään nuotit midi komennoiksi ja soitetaan 
%	statistics,
	sleep(3).

/* Staf = nuottiviivasto, eli käydään viivasto (kanava) kerrallaan läpi.
Prologissa asioita on kätevä käsitellä listoina.
Esimerkiksi [a,b,c,d] = [a|Loput], Loput = [b,c,d] */

stafs([],[],_):-!.
stafs([S1|Sn],[Ch1|Chn],Nsae):-
    staf(S1,Ch1,Nsae,0),!,
    stafs(Sn,Chn,Nsae).

staf([],Ch,0,Tf):- !,
    format('staf  Ch: ~d  Tf: ~d ~n',[Ch,Tf]).
staf([S1|Sn],Ch,Nsae,Ta):-
    Nsae > 0,
    g_link(n_sae,Nsae),
    soitin(Ch,_,Tahti),
    sae(Tahti,S1,Ch,Ta,Tf),!,
%    label(S1),!,
    is(K,Nsae-1),
    staf(Sn,Ch,K,Tf).

/*	random_vol([Dvol1,Dvol2,Dvol3,Dvol4,Dvol5,Dvol6,Dvol7,Dvol8]).
random_vol([]).
random_vol([X1|Xn]):-
  random(0,4,C),!,
  is(X1,5*C),
  random_vol(Xn).
*/



/* Säe on 3-4 tahdin jono tahtilajista riippuen.
Säkeen aluksi valitaan kanavalle määrätyistä instrumentteista satunnaisesti yksi, joka soittaa tällä kanavalla (Ch) tämän säkeen ajan.
Senjälkeen määrätään, miten kukin tahti jaetaan beateihin. Tähän on seitsemän-kahdeksan  sääntöä.  Senjälkeen määrätään, miten kukin beateista jaetaan edelleen osiin subbeateiksi. Tähän sovelletaan saman sääntökokoelman sääntöjä.
barx() tuottaa yhden tahdin. */

sae(t4,[B1,B2,B3],Ch,T0,Tf):-
    selectsoitin(Ch,Instrum,T0),
    Ta1 #=# T0+36,         % säkeen alkuun tyhjää
    set_tahti(t4,Tahti1,Ch),
    Ta2 #=# Tf1+9,        % tahtien väliin tyhjää, 3*sae(t4, ) yhtäpitkä kuin 4*sae(t3, )
    Ta3 #=# Tf2+9,
    lplim([P1,P1f,P2,P2f,P3,Pf],Instrum),
    barx(Tahti1,B1,Ch,Instrum,P1,P1f,Ta1,Tf1),
    barx(Tahti1,B2,Ch,Instrum,P2,P2f,Ta2,Tf2),
    barx(Tahti1,B3,Ch,Instrum,P3,Pf,Ta3,Tf3),
    Tf #=# Tf3+9.
/*
    fd_domain(Oct1,[5,7,12]),
    fd_domain(Dv1,[5,10,15,20]),
%    transpose(Oct1,B1,B2,0),
    transpose(Oct1,Dv1,B1,B3).
*/
sae(t3,[B1,B2,B3,B4],Ch,T0,Tf):-
    selectsoitin(Ch,Instrum,T0),
    Ta1 #=# T0+36,
    set_tahti(t3,Tahti1,Ch),
    Ta2 #=# Tf1+9,
    Ta3 #=# Tf2+9,
    Ta4 #=# Tf3+9,
    lplim([P1,P1f,P2,P2f,P3,P3f,P4,Pf],Instrum),
    barx(Tahti1,B1,Ch,Instrum,P1,P1f,Ta1,Tf1),
    barx(Tahti1,B2,Ch,Instrum,P2,P2f,Ta2,Tf2),
    barx(Tahti1,B3,Ch,Instrum,P3,P3f,Ta3,Tf3),
    barx(Tahti1,B4,Ch,Instrum,P4,Pf,Ta4,Tf4),
    Tf #=# Tf4+0.
/*
    fd_domain([Oct1,Oct2],[5,7,12]),
    fd_domain([Dv1,Dv2],[5,10,15,20]),
    Oct1 #\=# Oct2, 
    Dv1 #\=# Dv2, 
    transpose(Oct1,Dv1,B1,B3),
%    transpose(Oct1,B2,B3,0),
    transpose(Oct2,Dv2,B2,B4).
*/
/*
sae(t3,[B1,B2,B3,B4],Ch,T0,Tf):-
    selectsoitin(Ch,Instrum,T0),
    Ta1 #=# T0+18,
    set_tahti(t3,Tahti1,Ch),
    Ta2 #=# Tf1+18,
    Ta3 #=# Tf2+18,
%    Ta4 #=# Tf3+18,
    lplim([P1,P1f,P2,P2f,P3,P3f,P4,Pf],Instrum),
    barx(Tahti1,B1,Ch,Instrum,P1,P1f,Ta1,Tf1),
    barx(Tahti1,B2,Ch,Instrum,P2,P2f,Ta2,Tf2),
    barx(Tahti1,B3,Ch,Instrum,P3,P3f,Ta3,Tf3),
    barx(Tahti1,B4,Ch,Instrum,P4,Pf,Ta4,Tf),
%    fd_domain([Oct1,Oct2],0,2),
 %   Oct1 #\=# Oct2,
    transpose(1,B1,B2,0),
    transpose(1,B3,B4,0).
*/

/* Valitaan satunnaisesti joku kyseisen kanavan soitinlistalle määritellyistä instrumenteista */

selectsoitin(Ch,Instrum,Ta):-
    soitin(Ch,Instrums,_),
    length(Instrums,Len),
    is(N,Len+1),
    random(1,N,K),
    nth(K,Instrums,Instrum),
    instrument(_,Instrum,Prog,_),
%	write(selecsoitin(Ch,Instrums,Instrum,Prog)),nl,
    is(Cmd,191+Ch),
	is(Tx,Ta+2),
    assertz(midi_cmd(Tx,Cmd,Prog)),
    new_tempo(Ta).

soitinlista([]):- nl.
soitinlista([Ch1|Chn]):-
    soitin(Ch1,II,Tahti),
    write(II), write(' '), write(Tahti), write(';   '),
    soitinlista(Chn).


/* Määritetään tahdin ja beatin jaot.
Div1 määrittää tahdin osittelun beateiksi
Div1 määrittää beatin osittelun säveliksi
Div3 tarvitaan, kun en jaksanut miettiä ohjelmaa loppuun asti. */

set_tahti(t4,[Div1|[Div2,Div3]],_):-
    Div2=[Dv1,Dv2,Dv3,Dv4,xxxx],
%    Div2=[Dv1,Dv2,Dv1,Dv2,xxxx],
    Div3=[1,1,1,1,1],
    g_read(n_sae,N_sae),
    is(Vaihe,N_sae mod 3),
    setof(Index,divs(t4,Vaihe,Index),II),
    length(II,Len),
    is(Ix,Len+1),
    random(1,Ix,K),
    nth(K,II,Index),
%     g_read(n_divs_t4,M),     % vaihtoehtoja on M kappaletta
%   random(1,M,Index),        % valitaan satunnaisesti yksi niistä
    div_tahti(t4,Index,[Div1,Dv1,Dv2,Dv3,Dv4]).
%    format('t4: ~d tahti:~a beatit ~a  ~a  ~a  ~a~n',[Vaihe,Div1,Dv1,Dv2,Dv3,Dv4]).
set_tahti(t3,[Div1|[Div2,Div3]],_):-
%    Div2=[Dv1,Dv2,Dv1,Dv2,xxxx],
    Div2=[Dv1,Dv2,Dv3,Dv4,xxxx],
    Div3=['1_1','1_1','1_1','1_1','1_1'],
    g_read(n_sae,N_sae),
    is(Vaihe,N_sae mod 2),
    setof(Index,divs(t3,Vaihe,Index),II),
    length(II,Len),
    is(Ix,Len+1),
    random(1,Ix,K),
    nth(K,II,Index),
%    g_read(n_divs_t3,M),
 %   random(1,M,Index),
    div_tahti(t3,Index,[Div1,Dv1,Dv2,Dv3,Dv4]).
%    format('t3: ~d tahti:~a beatit ~a  ~a  ~a  ~a~n',[Vaihe, Div1,Dv1,Dv2,Dv3,Dv4]).

divs(Tahtilaji,Vaihe,Index):-
    div_tahti(Tahtilaji,Index,[Div1,Dv1,Dv2,Dv3,Dv4]).
%    ntempo(Tahtilaji,Vaihe,Low,High),
%   note_count([Div1,Dv1,Dv2,Dv3,Dv4],Notes),
%    Low =< Notes, Notes =< High.

ntempo(t4,0,4,8).
ntempo(t4,1,8,11).
ntempo(t4,2,10,14).

ntempo(t3,0,4,8).
ntempo(t3,1,7,11).

/*
ntempo(t4,0,5,7).
ntempo(t4,1,8,11).
ntempo(t4,2,12,14).
%ntempo(t4,3,13,14).

ntempo(t3,0,4,7).
ntempo(t3,1,8,11).
%ntempo(t3,2,9,10).
*/

/* Ohjelman alussa luodaan ja talletetaan mahdolliset tahtivaihtoehdot.
Jaot_h kertoo vaihtoehtoiset tavat osittaa tahti,
Jaot_l kertoo vaihtoehtoiset tavat osittaa beat.
t4 viittaa 4 1/4 nuotin mittaiseen tahtiin ja
t3 viittaa 3 1/4 nuotin mittaiseen tahtiin.
Niille voi määritellä omat jaottelunsa. Luontevaa olisi esimerkiksi sallia t3:lle jaot '1/3_2/3' ja  '1/3_1/3_1/3'
Olen kokeillut kaikenlaista. Puhdasoppiset säännöt tuottavat aika tylsää musiikkia. Omalaatuinen polyrytmisyys on tämän ohjelman erikoisuus. Siksi alla on nyt ihan hulluja jakoja.
 */

%['1_1', '1/2_1/2', '1/3_1/3_1/3', '1/4_1/4_1/4_1/4', '1/3_2/3', '2/3_1/3', '1/4_1/4_1/2', '1/2_1/4_1/4', '1/4_1/2_1/4']
assert_tahdit_t4:-
    g_assign(n_divs_t4,0),
    Jaot_h=['1/4_1/4_1/4_1/4', '1/4_1/4_1/2', '1/2_1/4_1/4'],
%    Jaot_h=['1/4_1/4_1/4_1/4'],
%    Jaot_l=['1_1', '1/2_1/2', '1/3_1/3_1/3', '1/4_1/4_1/4_1/4', '1/3_2/3', '2/3_1/3', '1/4_1/4_1/2', '1/2_1/4_1/4'],
%    Jaot_l=['1/2_1/2', '1/4_1/4_1/4_1/4', '1/4_1/4_1/2', '1/2_1/4_1/4'],
    Jaot_l=['1/2_1/2', '1/3_1/3_1/3', '1/4_1/4_1/4_1/4', '1/3_2/3', '2/3_1/3', '1/4_1/4_1/2', '1/2_1/4_1/4'],
    member(Div1,Jaot_h),
    member(Dv1,Jaot_l),
    member(Dv2,Jaot_l),
    member(Dv3,Jaot_l),
    member(Dv4,Jaot_l),
%	all_different([Dv1,Dv2,Dv3,Dv4]),
    note_count([Div1,Dv1,Dv2,Dv3,Dv4],Notes),
    Notes > 8, Notes < 14,
    g_inc(n_divs_t4,Ndiv),
    assertz(div_tahti(t4,Ndiv,[Div1,Dv1,Dv2,Dv3,Dv4])),
    fail.
assert_tahdit_t4:- g_inc(n_divs_t4,_).

assert_tahdit_t3:-
    g_assign(n_divs_t3,0),
    Jaot_h=['1/3_1/3_1/3', '1/3_2/3', '2/3_1/3'],
%    Jaot_h=['1/3_1/3_1/3'],
    Jaot_l=['1/2_1/2', '1/3_1/3_1/3', '1/4_1/4_1/4_1/4', '1/3_2/3', '2/3_1/3', '1/4_1/4_1/2', '1/2_1/4_1/4'],
%    Jaot_l=['1_1', '1/2_1/2', '1/3_1/3_1/3', '1/4_1/4_1/4_1/4', '1/3_2/3', '2/3_1/3', '1/4_1/4_1/2', '1/2_1/4_1/4'],
%    Jaot_l=['1/2_1/2', '1/3_1/3_1/3', '1/4_1/4_1/4_1/4', '1/3_2/3', '2/3_1/3', '1/4_1/4_1/2', '1/2_1/4_1/4'],
    member(Div1,Jaot_h),
    member(Dv1,Jaot_l),
    member(Dv2,Jaot_l),
    member(Dv3,Jaot_l),
    member(Dv4,Jaot_l),
%	all_different([Dv1,Dv2,Dv3,Dv4]),
%	(Dv1=Dv2;Dv1=Dv3; Dv1=Dv4; Dv2=Dv3; Dv2=Dv4; Dv3=Dv4),
   note_count([Div1,Dv1,Dv2,Dv3,Dv4],Notes),
   Notes > 6, Notes < 10,
    g_inc(n_divs_t3,Ndiv),
    assertz(div_tahti(t3,Ndiv,[Div1,Dv1,Dv2,Dv3,Dv4])),
    fail.
assert_tahdit_t3:- g_inc(n_divs_t3,_).

all_different([_]).
all_different([H|[H|_]]):- !,fail.
all_different([A|[B|T]]):-
	all_different([A|T]),
	all_different([B|T]).

/* Oikeassa musiikissa näytään käyttävän pääosin tietyn kestoista nuottia, eli tahdissa on aina suurinpiirtein sama määrä nuotteja. Alla lasketaan eri jakojen tuottamat nuottien lukumäärät tahdille. Yllä näkyy, että sallin suuret vaihtelut.
Nyt tahdin nuottien määrät rajataan koko kappaleen ajaksi. Toteuttamalla set_tahti() toisin, nuottien sallittua lukumäärää voitaisiin vaihdella säe-kohtaisesti. Tämän voisi vielä yhdistää tempon vaihtelemiseen niin, että tulisi mahdolliseksi vaihdella keskimääräisen nuotin kestoa. Nyt tempon ja tahdin vaihtelu joko eliminoivat tai vahvistavat toisiaan. Soitetaan hitaalla tempolla monta nuottia per tahti tai toisinpäin. */

note_count([Div1,Dv1,Dv2,Dv3,Dv4],Notes):-
    div_cnt(Div1,M1),
    div_cnt(Dv1,N1),
    div_cnt(Dv2,N2),
    div_cnt(Dv3,N3),
    div_cnt(Dv4,N4),
    (M1=1 -> Notes=N1
    ; M1=2 -> is(Notes,N1+N2)
    ; M1=3 -> is(Notes,N1+N2+N3)
    ; M1=4 -> is(Notes,N1+N2+N3+N4)).

div_cnt('1_1',1).
div_cnt('1/2_1/2',2).
div_cnt('1/3_1/3_1/3',3).
div_cnt('1/4_1/4_1/4_1/4',4).
div_cnt('1/3_2/3',2).
div_cnt('2/3_1/3',2).
div_cnt('1/4_1/4_1/2',3).
div_cnt('1/2_1/4_1/4',3).
div_cnt('1/4_1/2_1/4',3).

