
/* playnotes.pl */
 /*  Heikki Välisuo */

/* Stafs on listojen lista kunkin Stafin säkeiden Bareista. 
Tehdään nuoteista midi-komentoja. Senjälkeen ne kirjoitetaan midi-syntetisaattorille (timidity++) ja lisäksi tiedostoon "nuottiviivastolle" piirtelyä yms. varten. */ 

playnotes(Stafs,Midi,Fmid,Chs):-
%    panning(Chs),
    assert_stafs(Stafs),!,
    dump_notes(Chs),!,
    notes_out(Midi),!,            % writing the MIDI command bytes out 
    flush_output(Midi),
    flush_output(Fmid),
    close(Fmid), close(Midi),
   exec('timidity -c timi.cfg -A100,0a --anti-alias --verbose=0 --chorus=n,120 --reverb=f,120  "midi.tmp"',_,_,_,Pid),
    write(waiting(Pid)),nl,
    wait(Pid,Status), write(finished(Pid,Status)),nl.

% --fast-decay
% --volume-compensation 

%    exec('timidity -c timi.cfg  --volume=100, --drum-power=100 --chorus=s,100 --reverb=G,100  --anti-alias --temper-control --polyphony-reduction --noise-shaping=4 --verbose=0 "midi.tmp"', _,_,_,Pid),
%    wait(Pid,_).

panning(Chs):-
    pan(Chs,100).

pan([],_).
pan([Ch1|Chn],LR):-
    is(Cmd, Ch1+176),
    assertz(midi_cmd4(0,Cmd,10,LR)),
    (LR = 100 -> LR1 = 27; LR1 = 100),
    pan(Chn,LR1).
        

/* Heitetään kaikki nuotit midi-komentojen muodossa isoon laariin. ;-) */

assert_stafs([]).
assert_stafs([S1|Sn]):-
    assert_sakeet(S1),
    assert_stafs(Sn).

assert_sakeet([]).
assert_sakeet([S1|Sn]):-
    message(assert_beats(S1)),
    assert_beats(S1),
    assert_sakeet(Sn).

assert_beats([]).
assert_beats([B1|Bn]):-
    assert_beat(B1),
    assert_beats(Bn).
    
assert_beat([]).
assert_beat([note(Ta,Ch,_,D,P,V)|Bn]):-
    is(Te,Ta + D-4),
%    is(Te2,Te+1),
    is(Ch_on, Ch+143),is(Ch_off, Ch+127),
    assertz(midi_cmd4(Ta,Ch_on,P,V)),    % ala soittaa nuottia 
    assertz(midi_cmd4(Te,Ch_off,P,V)),    % lopeta soittaminen
%    assertz(midi_cmd4(Te1,Ch_off,P,0)),    % lopeta soittaminen
    assert_beat(Bn).


/*
Octave||                     Note Numbers
   #  ||
      || C   | C#  | D   | D#  | E   | F   | F#  | G   | G#  | A   | A#  | B
------------------------------------------------------------------------------
   0  ||   0 |   1 |   2 |   3 |   4 |   5 |   6 |   7 |   8 |   9 |  10 |  11
   1  ||  12 |  13 |  14 |  15 |  16 |  17 |  18 |  19 |  20 |  21 |  22 |  23
   2  ||  24 |  25 |  26 |  27 |  28 |  29 |  30 |  31 |  32 |  33 |  34 |  35
   3  ||  36 |  37 |  38 |  39 |  40 |  41 |  42 |  43 |  44 |  45 |  46 |  47
   4  ||  48 |  49 |  50 |  51 |  52 |  53 |  54 |  55 |  56 |  57 |  58 |  59
   5  ||  60 |  61 |  62 |  63 |  64 |  65 |  66 |  67 |  68 |  69 |  70 |  71
   6  ||  72 |  73 |  74 |  75 |  76 |  77 |  78 |  79 |  80 |  81 |  82 |  83
   7  ||  84 |  85 |  86 |  87 |  88 |  89 |  90 |  91 |  92 |  93 |  94 |  95
   8  ||  96 |  97 |  98 |  99 | 100 | 101 | 102 | 103 | 104 | 105 | 106 | 107
   9  || 108 | 109 | 110 | 111 | 112 | 113 | 114 | 115 | 116 | 117 | 118 | 119
  10  || 120 | 121 | 122 | 123 | 124 | 125 | 126 | 127 |


*/


/*
Duurissa on seitsemän säveltä, joiden väliset korkeuserot sävelaskelin ilmaistuina ovat 1–1–½–1–1–1–½.
*/
   