dynamic(bar/3).

go(Tahti_laji):-
    retractall(bar),!,
    asserta(bar([],[],[])),
    fd_set_vector_max(255),
    fd_domain(N_notes,2,8),
    length(Pitches,N_notes), length(Volumes,N_notes), length(Durations,N_notes),
    random(0,100,Pmin),!,
    is(Pmax,min(Pmin+12,120)),
    fd_domain(Pitches,Pmin,Pmax),
    fd_domain(Volumes,[0,5,10,15,20,25,30,35,40,45,50,55,60,65,70,75,80,85,90,95,100,105,110,115,120]),
    durations(Tahti_laji, Durations),
    tahti(Tahti_laji, Pitches, Volumes, Durations,N_notes),
    fd_labeling(Pitches,[variable_method(most_constrained),value_method(random)]),
    fd_labeling(Volumes,[variable_method(most_constrained),value_method(random)]),
    fd_labeling(Durations,[variable_method(most_constrained),value_method(random)]),
%    different(Volumes,Pitches,Durations),
    write('      pitches:  '),write(Pitches),
    write('      volumes:  '),write(Volumes),
    write('      durations:  '),write(Durations),nl,
    fail.

durations(t_44,Durations):- fd_domain(Durations,[9,18,36,72]).
durations(t_34,Durations):- fd_domain(Durations,[5,16,48]).

tahti(Tahti_laji, Pitches, Volumes, Durations,N_notes):-
    beats(Tahti_laji,Durations,144),
    sum(Durations,T),
    140 #=<# T, T #=<# 144,
    50 #=<# V_isku, V_isku #=<# 80,
    V_isku-30 #=<# Vx, Vx #=<# V_isku-10,
    volumes(Tahti_laji,Volumes,V_isku,Vx,Durations,0),
    pitches(Pitches,N_notes),
    fd_all_different(Pitches).
    
volumes( _,[],_,_,_,_).
volumes(t_44, [V0|Vn],V_isku,Vx,[D0|Dn],T0):-
    T1 #=# T0+D0,
    isku(t_44,T0,T1,V0,V_isku,Vx),
    volumes(t_44, Vn,V_isku,Vx,Dn,T1).

volumes(t_34, [V0|Vn],V_isku,Vx,[D0|Dn], T0):-
    T1 #=# T0+D0,
    isku(t_34,T0,T1,V0,V_isku,Vx),
    volumes(t_34, Vn,V_isku,Vx,Dn,T1).

isku(t_44,_,T1,V0,V_isku,_):- T1 #=<# 36, !, V0 #=# V_isku.
isku(t_44,T0,T1,V0,V_isku,_):- 
    71 #=<# T0, T1 #<# 109,!,
    V0 #=# V_isku-5. 
isku(t_44,_,_,Vx,_,Vx).

isku(t_34,_,T1,V0,V_isku,_):- T1 #=<# 48, !, V0 #=# V_isku.
isku(t_34,_,_,Vx,_,Vx).

pitches(Pitches,N_notes):- 
    deriv(Pitches,Dsum),
    Dsum // N_notes #=<# 6.
  
deriv([P1,P2],D):-
    D #=# dist(P1,P2), 
    1 #=<# D, D #=<8.
deriv([P1|[P2|Pn]],Dsum0):-
    deriv([P2|Pn],Dsumn),
    D #=# dist(P1,P2), 
    1 #=<# D, D #=<10,
    Dsum0 #=# D+Dsumn.

sum([],0).
sum([X0|Xn],S0):-
    sum(Xn,Sn),
    S0 #=# X0+Sn.
 
different(V,P,D):-
    similar_exists(V,P,D),!,fail.
different(V,P,D):- asserta(bar(V,P,D)).    
 
similar_exists(V,P,D):-
    bar(V1,P1,D1),
    (P == P1; D == D1).

beats(t_44,D,N):-
    N #>=# 10,
    N2 #=# N//2,
    beats(t_44,D1,N2),
    beats(t_44,D2,N2),
    append(D1,D2,D).

beats(t_44,[X],N):-
    N #=<# 140, N #>=# 10,
    X #=# N.

beats(t_34,D,N):-
    N >= 6,
    is(N3, N //3),
    beats(t_34,D1,N3),
    beats(t_34,D2,N3),
    beats(t_34,D3,N3),
    append(D1,D2,D3,D).

  /*
  min(E1,E2) 	minimum of E1 and E2
max(E1,E2) 	maximum of E1 and E2
dist(E1,E2) 	distance, i.e. |E1 - E2|
E1 // E2 	quotient of the integer division of E1 by E2
E1 rem E2 	remainder of the integer division of E1 by E2
quot_rem(E1,E2,R) 	quotient of the integer division of E1 by E2
(R is the remainder of the integer division of E1 by E2)

#=#, #\=#, #<#, #=<#, #># and #>=# 

and(X,Y,Z):-
        fd_relation([[0,0,0],[0,1,0],[1,0,0],[1,1,1]], [X,Y,Z]).
  
  
  */