
/* tests.pl */

/* kaikenlaista testailua varten */

%db:- spypoint_condition(bar(_,_,_,_,_,_,_,_,_,J), _, J=savel(loppu)).
db:- spypoint_condition(pick_notes(_, _, _, _, _, _, _), fail, true).

dbspy:- spy([sointu_steps, init_level,end_level,connect_level]),mel([1,2]).
deb:- trace,leash([]).
debfail:- trace,leash([fail]),melody(56,2,[1,2]).

mm(A):- mel([A]). 
mm(A,B):- mel([A,B]). 
mm(A,B,C):- mel([A,B,C]). 

mel(Chs):- 
    melody(72,1,Chs).

generate:-
    open('asteikko.pl',write,File),
    generate(File),
    close(File).
generate(F):-
    instrument(_,I,N,0),
    format(F,'test(~d,Oct):- is(Pa,Oct*12),is(Pf,Pa+12),asteikko(''~a'',Pa,Pf).~n',[N,I]),
    fail.
generate(_).

test_all:-
    for(I,0,117),
    test(I,2),test(I,4),test(I,6),nl,fail.

urut:- melody(36,12,[12,13,14,15]).

/*
test(0):- asteikko('YamahaGrandPiano',0,49).
test(1):- asteikko('HonkyTonk',0,49). % huono
test(2):- asteikko('BaritoneSax',0,49).  % huono
test(3):- asteikko('ChurchOrgan',0,49).
test(4):- asteikko('FrenchHorns',0,49).
test(5):- asteikko('Trumpet',0,49).
test(6):- asteikko('BrassSection',0,49).
test(7):- asteikko('JazzGuitar',0,49).
test(8):- asteikko('Harpsichord',0,49).
test(9):- asteikko('AcousticBass',0,49).
test(10):- asteikko('SynthBrass1',0,49).
test(11):- asteikko('Flute',0,49).
test(12):- asteikko('Ocarina',0,49).
test(13):- asteikko('TinkerBell',0,49).
test(14):- asteikko('Celesta',0,49).
test(15):- asteikko('Glockenspiel',0,49).
test(16):- asteikko('Vibraphone',0,49).
test(17):- asteikko('Marimba',0,49).
test(18):- asteikko('Xylophone',0,49).
test(19):- asteikko('TubularBells',0,49).
test(20):- asteikko('Dulcimer',0,49).
test(21):- asteikko('DrawbarOrgan',0,49).
*/

vol_test(1):- vol_asteikko('Flute',0,125).
vol_test(2):- vol_asteikko('YamahaGrandPiano',0,125).
vol_test(3):- vol_asteikko('Trumpet',0,125).

pick_soitin(Soitin):- instrument(_,Soitin,_,0).

ryhmat:-
    setof(R,r(R),RR),
    soittimet(RR).

soittimet([]).
soittimet([R1|Rn]):-
    write(R1), write(' '),
    setof(S,sr(R1,S),SS),
    write(SS),nl,
    soittimet(Rn).

r(R):- instrument(R,_,_,_).
sr(R,S):- instrument(R,S,_,_).
ss(S):- instrument(_,S,_,_).

v_all(Ryhma):-
    sel_instrum([Ryhma],SS),
    write(SS),nl,
    vol_all(SS).

vol_all([]).
vol_all([S1|Sn]):-
    vol_asteikko(S1,40,125),sleep(5),
    vol_all(Sn).
    
all:-
    for(I,0,13),test(I),fail.
%    test(0), test(1),test(2),test(3),test(4),test(5),test(6),test(7),test(8),
%    test(9),test(10),test(11),test(12),test(13).


vol_asteikko(Instrument,Va,Vf):-
    init(Midi,Fmid,[1]),
    vol_step(Instrument,Va,Vf,SS),
    set_prog(SS,0),
    assert_beat(SS),
    midi_init2(Midi,72),
    notes_out(Midi),            % writing the MIDI command bytes out 
    flush_output(Midi),
    flush_output(Fmid),
    close(Fmid), close(Midi).
%    debu.

debu:-
    midi_cmd(T0,Cmd,Prog),
    write(midi_cmd(T0,Cmd,Prog)),nl,fail.
debu.

step(_,P,Pf,[],_):- P >= Pf.    
step(Instr,P,Pf,[S1|[S1b|[S1c|[S2|Sn]]]],T0):-
    is(Pb,P+4),
    is(Pc,P+7),
    is(T0b,T0+144),
    is(T0c,T0b+72),
    S1=note(T0,1,Instr,144,P,100),
    S1b=note(T0b,1,Instr,72,Pb,100),
    S1c=note(T0c,1,Instr,36,Pc,100),
    is(T1,T0c+36),
    S2=note(T1,1,Instr,72,P,0),
    is(P1,P+1), is(Tf,T1+72),
    step(Instr,P1,Pf,Sn,Tf).

drum(N):- drum_asteikko(N,N).
drum_test:- drum_asteikko(35,81).
drum_asteikko(Pa,Pf):-
    write(asteikko(percussion,Pa,Pf)),nl,
    init(Midi,Fmid,[10]),
    drum_step(Pa,Pf,SS,2),
%    set_prog(SS,0),
%   instrument(_,Instrument,Prog,_), 
     is(Cmd,191+1),
    assertz(midi_cmd(0,Cmd,11)),
    assert_beat(SS),
    midi_init2(Midi,72),
  new_tempo(0),
    notes_out(Midi),            % writing the MIDI command bytes out 
    flush_output(Midi),
    flush_output(Fmid),
    close(Fmid), close(Midi),!,
   exec('timidity -c timi.cfg  --volume=80 --drum-power=80 --chorus=s --reverb=G --anti-alias --temper-control --polyphony-reduction --noise-shaping=4 --verbose=0 "midi.tmp"', _,_,_,Pid),
    write(waiting(Pid)),nl,
    wait(Pid,Status), write(wait(Pid,Status)),nl,!.

drum_step(P,Pf,[],_):- P > Pf.    
drum_step(P,Pf,[S1|[S1b|[S1c|[S2|Sn]]]],T0):-
    is(T0b,T0+36),
    is(T0c,T0b+36),
    S1=note(T0,10,Instr,36,P,100),
    S1b=note(T0b,10,Instr,36,P,100),
    S1c=note(T0c,10,Instr,36,P,100),
    is(T1,T0c+36),
    S2=note(T1,10,Instr,72,P,0),
    is(P1,P+1), is(Tf,T1+72),
    drum_step(P1,Pf,Sn,Tf).

vol_step(_,V,Vf,[]):- V > Vf.    
vol_step(Instr,V,Vf,SS):-
    V =< Vf,
    S1=note(1,Instr,36,0,V),
    S2=note(1,Instr,4,0,0),
    S3=note(1,Instr,36,12,V),
    S4=note(1,Instr,4,12,0),
    S5=note(1,Instr,36,24,V),
    S6=note(1,Instr,4,24,0),
    S7=note(1,Instr,36,35,V),
    S8=note(1,Instr,72,35,0),
    is(V1,V+10),
    vol_step(Instr,V1,Vf,Sn),
    append([S1,S2,S3,S4,S5,S6,S7,S8],Sn,SS).

qbeat(BeatMin,Tempo):-
    is(Tempo,60/BeatMin*1000000).

test_dupl:-
    A = [[1,2,3],[1,5,6],[2,3,4],[3,4,5],[3,6,7]],
    duplicates(A,X),
    write(A),write('  '),write(X),nl.

cst(A):-
    fd_domain(A,0,50),
    cs(A),
    fd_labeling(A).

cs(A):-
    (3 #=<# A #/\ A #=<# 7) #\/
    (13 #=<# A #/\ A #=<# 17).

exetst:-
    exec('timidity -c timi.cfg  --volume=100, --drum-power=100 --chorus=s,100 --reverb=G,100  --anti-alias --temper-control --polyphony-reduction --noise-shaping=4 --verbose=0 "musa_1_2.mid"', _,_,_,Pid),
    write(waiting(Pid)),nl,
    wait(Pid,_).

test_dynamic:-
    tahti(A,B),
    write(tahti(A,B)),nl,
    fail.
test_dynamic.
